// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

// KIK.cpp
//
// muss mit KGRA zu einem Paket zusammengefgt werden

#include	<iostream>
#include	<fstream>
#include	<string>
using namespace std;

#define ERR            0
#define NOERR          1
#define UNGLEICH       0
#define GLEICH         1
#define MAXKNOT        2000
#define MAXLIST        4000
#define HOECHST        35
#define TIEFST         -35
#define MAXSTIM        5
#define MAXTIEF        20
#define PAUSE          -0x8000
#define ANFANGSTON     0
#define ANFANG         0
#define DISS           0
#define KONS           1
#define PRIM           0
#define QUART          3
#define QUINT          4
#define OKTAV          7
#define MIT_PARALL     0
#define OHNE_PARALL    1
#define BIT_DREIKLANG  21
#define BIT_OBEROKTAV  0x3f80
#define BIT_UNTEROKTAV 0x7f

struct  liste
  {
  struct  knoten  *kn;
  struct  liste   *folg;
  };

struct  knoten
  {
  int             ivl;
  int             nummer;
  struct  knoten  *klasse;
  struct  liste   *adj;
  struct  liste   *inz;
  };

int satz[MAXSTIM][MAXTIEF];
int anz_lst;
int anz_knt;
int kont_lst;
int kont_knt;
struct  liste *lstr;
struct  knoten *kntr;
int maxabst;
int maxsprung;
int kanon_tiefe;
int unters_tiefe;
int anz_stim;
int i_abs[MAXSTIM];
int r_abs[MAXSTIM];
int schritte[MAXTIEF / 2];
int weg[MAXTIEF / 2];
char  *ivl_name[] = {"Prim", "Sekund", "Terz", "Quart", "Quint", 
                    "Sext", "Septim", "Oktav"};
ofstream  fp;
struct  knoten wurzel;

int betrag(int x)
{
  if(x < 0)
    return(-x);
  return(x);
}

int	zahlein(int *zahl, int min, int max)
{
  do
    {
	cin >> *zahl;
    if(*zahl > max)
      cout << "Eingabe zu gro" << endl;
    else if(*zahl < min)
      cout << "Eingabe zu klein" << endl;
    }
  while(*zahl > max || *zahl < min);
  return(NOERR);
}

int	pitch_class(int t)
{
  if(t < 0)
    return(6 - ((-1 - t) % 7));
  return(t % 7);
}

// Die folgenden Funktionsdeklarationen sollten woanders hin

int parallelen(int * vh, int * nh, int n);
int bass_quart(int * v, int n);
int kons(int * v, int n);

int	prf_parallelen(int z)
{
  int i;
  int akkord1[MAXSTIM];
  int akkord2[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
    for(i = 0, z--; i < anz_stim; i++)
      akkord2[i] = satz[i][z];
    return(parallelen(akkord2, akkord1, anz_stim));
}

int	parallelen(int * vh, int * nh, int n)
{
  int i, j, ivl, ni, vi, nj;
  for(i = 0; i < n - 1; i++)
    {
    if((ni = nh[i]) != PAUSE && (vi = vh[i]) != PAUSE)
      if(ni != vi)
        for(j = i + 1; j < n; j++)
          {
          if((nj = nh[j]) != PAUSE)
            if((ivl = (betrag(ni - nj) % 7)) == QUINT || ivl == PRIM)
              if(ni - nj == vi - vh[j])
                return(MIT_PARALL);
          }
    }
  return(OHNE_PARALL);
}

int	prf_bass_quart(int z)
{
  int i;
  int akkord1[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
  return(bass_quart(akkord1, anz_stim));
}

int	bass_quart(int * v, int n)
{
  int bs_ton, akk, i, t;

  for(akk = i = 0, bs_ton = PAUSE; i < n; i++)
    {
    if((t = v[i]) != PAUSE)
      {
      if(bs_ton == PAUSE || bs_ton > t)
        bs_ton = t;
      akk |= (1 << pitch_class(t));
      }
    }
  if(akk == 0)
    return(KONS);
  return(((1 << pitch_class(bs_ton + QUART)) & akk) != 0 ? DISS : KONS);
}

int	prf_kons(int z)
{
  int i;
  int akkord1[MAXSTIM];
  for(i = 0; i < anz_stim; i++)
    akkord1[i] = satz[i][z];
  return(kons(akkord1, anz_stim));
}

int	kons(int * v, int n)
{
  int pc, dr, kons_grad;
  for(kons_grad = 0x7f; kons_grad != 0 && n > 0; n--, v++)
    if(*v != PAUSE)
      {
      pc = pitch_class(*v);
      if((dr = BIT_DREIKLANG << pc) > BIT_UNTEROKTAV)
        dr = ((BIT_OBEROKTAV & dr) >> 7) | (BIT_UNTEROKTAV & dr);
      kons_grad &= dr;
      }
  return(kons_grad != 0 ? KONS : DISS);
}

void kanon_schema()
{
  int i, flag, letztmoeglich;
  char  c;

  letztmoeglich = (MAXTIEF - 1) / 2;
  maxabst = 0;
  i_abs[0] = 0;
  r_abs[0] = 0;
  cout << "Eingabe 2. Stimme" << endl;
  do
    cout << "Rhythmischer Einsatzabstand" << endl;
  while(zahlein(r_abs + 1, 0, letztmoeglich) == ERR);
  if(r_abs[1] > maxabst)
    maxabst = r_abs[1];
  do
    cout << "Intervallischer Einsatzabstand" << endl;
  while(zahlein(i_abs + 1, TIEFST, HOECHST) == ERR);
  for(flag = 1, i = 2; i < MAXSTIM && flag; i++)
    {
    do
      {
      cout << "Eingabe "<< i + 1 << ". Stimme? (j/n)" << endl;
      cin >> c;
      }
    while(c != 'j' && c != 'J' && c != 'n' && c != 'N');
    if(c == 'j' || c == 'J')
      {
      do
        cout << "Rhythmischer Einsatzabstand" << endl;
      while(zahlein(r_abs + i, 0, letztmoeglich) == ERR);
      if(r_abs[i] > maxabst)
        maxabst = r_abs[i];
      do
        cout << "Intervallischer Einsatzabstand" << endl;
      while(zahlein(i_abs + i, TIEFST, HOECHST) == ERR);
      }
    else
      flag = 0;
    }
  if(flag == 1)
    anz_stim = MAXSTIM;
  else
    anz_stim = i - 1;
  return;
}

void weite()
{
  do
    cout << "Groesster Sprung?" << endl;
  while(zahlein(&maxsprung, 1, 7) == ERR);
	return;
}

void kgra_kopf(ostream& f)
{
  int i;
  f << "Kanongraph zu folgendem Einsatzschema" << endl;
  f << "Stimme Rhythm. Abs. Interv.Abs" << endl;
  for(i = 0; i < anz_stim; i++)
      f << i + 1 << "\t" << r_abs[i] << "\t" << i_abs[i] << endl;
  f << "Groesstmoeglicher Sprung: " << ivl_name[maxsprung] << endl;
	return;
}

/******************** ab hier darf programmiert werden ********/
/* j <= maxabst ist ein Sonderfall */

#define MAXWEITE        7
#define SEKUND          1
#define TERZ            2
#define SEXT            5
#define SEPTIM          6
#define IRRELEVANT      0
#define DISSONATIV      1
#define PERFEKTIV       2
#define IMPERFEKTIV     3
#define AMBIVALENT      4
#define KORRQUART       2
#define REGULAER        0
#define IRREGULAER      1
#define ENDE_FEHLER     -1
#define VAR_AUSGABE     0
#define VAR_BERECHNUNG  1

ofstream	f_aus;
ofstream	f_sp;

int haeuf[MAXTIEF / 2];
int basis[MAXTIEF / 2];
int anz_versch;
int variation[MAXTIEF / 2];
int var_haeuf[MAXTIEF / 2];
int var_len;

int z_irrelevant;
int z_regulaer;
int z_irregulaer;

char  *chr_name[] = 
  {"irrelevant", "dissonativ", "perfektiv", "imperfektiv", "ambivalent"};
char  *richtung[] = {"abw.", " ", "aufw."};
int quart_flag;

struct  fortschreitung
  {
  int fs;
  int cr;
  };

struct  fortschreitung  fs_c[2 * MAXWEITE + 1];
struct  fortschreitung  bfs[2 * MAXWEITE + 1];

int f_komb[MAXTIEF / 2];
int anz_bfs;

struct  teilkanon
  {
  int rhy_abs;
  int ivl_abs;
  };

struct  teilkanon alletks[MAXSTIM * (MAXSTIM - 1) / 2];
int anz_tks;

void ber_tks()
{
  int i, j, k, d;
  k = 0;
  for(i = 0; i < anz_stim - 1; i++)
    for(j = i + 1; j < anz_stim; j++)
      {
      if((d = r_abs[i] - r_abs[j]) < 0)
        {
        alletks[k].rhy_abs = -d;
        alletks[k].ivl_abs = i_abs[j] - i_abs[i];
        }
      else  if(d == 0)
        {
        alletks[k].rhy_abs = 0;
        alletks[k].ivl_abs = betrag(i_abs[j] - i_abs[i]);
        }
      else
        {
        alletks[k].rhy_abs = d;
        alletks[k].ivl_abs = i_abs[i] - i_abs[j];
        }
      k++;
      }
  anz_tks = anz_stim * (anz_stim - 1) / 2;
}

int	vergl(int x, int y)
{
  if(alletks[x].rhy_abs != alletks[y].rhy_abs)
    return(alletks[x].rhy_abs - alletks[y].rhy_abs);
  return(alletks[x].ivl_abs - alletks[y].ivl_abs);
}

void sort_tks()
{
  int i, j, min_index, hr, hi;
  for(i = 0; i < anz_tks - 1; i++)
    {
    min_index = i;
    for(j = i + 1; j < anz_tks; j++)
      if(vergl(j, min_index) < 0)
        min_index = j;
    if(vergl(i, min_index) > 0)
      {
      hr = alletks[i].rhy_abs;
      hi = alletks[i].ivl_abs;
      alletks[i].rhy_abs = alletks[min_index].rhy_abs;
      alletks[i].ivl_abs = alletks[min_index].ivl_abs;
      alletks[min_index].rhy_abs = hr;
      alletks[min_index].ivl_abs = hi;
      }
    }
  return;
  }

void versch_tks()
{
  int i, j;
  for(i = 1, j = 0; i < anz_tks; i++)
    if(vergl(i, j) != 0)
      {
      j++;
      alletks[j].rhy_abs = alletks[i].rhy_abs;
      alletks[j].ivl_abs = alletks[i].ivl_abs;
      }
  anz_tks = j + 1;
  return;
}

int charakter(int x)
{
  x = (x < 0 ? -x : x);
  x %= 7;
  if(x == PRIM || x == QUINT)
    return(PERFEKTIV);
  if(x == TERZ || x == SEXT || (x == QUART && quart_flag != DISS))
    return(IMPERFEKTIV);
  return(DISSONATIV);
}

int vorz(int x)
{
  if(x < 0)
    return(-1);
  if(x > 0)
    return(1);
  return(0);    
}

int	minimum(int x, int y)
{
  return(x < y ? x : y);
}

void unt_tks()
{
  int i, j, f, flag;
  /* Gibt es einen Teilkanon mit rhy_abs == 1? */
  for(i = 0; i < anz_tks && alletks[i].rhy_abs < 1; i++)
    ;
  if(i == anz_tks || alletks[i].rhy_abs != 1)
    cout << "Dieses Kanonschema kann nicht bearbeitet werden" << endl;
  else
    {
    flag = 0;
    do
      {
      for(j = 0, f = maxsprung; f >= -maxsprung; j++, f--)
        {
        if(flag == 0)
          {
          fs_c[j].fs = f;
          fs_c[j].cr = charakter(f - alletks[i].ivl_abs);
          }
        else
          fs_c[j].cr = minimum(fs_c[j].cr, charakter(f - alletks[i].ivl_abs));
        }
      i++;
      flag = 1;
      }
      while(alletks[i].rhy_abs == 1);
    }
  return;
}

void brauchbare_fs()
{
  int i, j;

  for(i = j = 0; i < 2 * maxsprung + 1; i++)
    if(fs_c[i].cr > DISSONATIV)
      {
      bfs[j].fs = fs_c[i].fs;
      bfs[j].cr = fs_c[i].cr;
      j++;
      }
  anz_bfs = j;
  return;
}

void aus_bfs(ostream& file)
{
  int i, v;
  if(anz_bfs == 0)
    file << "Es gibt keine brauchbaren Fortschreitungen" << endl;
  else
    {
    file << "Quarte ";
    if(quart_flag == KONS)
      file << "generell als Konsonanz" << endl;
    else if(quart_flag == DISS)
      file << "generell als Dissonanz" << endl;
    else
      file << "je nach Lage" << endl;
    file << "Brauchbare Fortschreitungen:" << endl;
    for(i = 0; i < anz_bfs; i++)
      {
      file << betrag(bfs[i].fs) + 1;
      if((v = vorz(bfs[i].fs)) < 0)
        file << "-";
      else if(v > 0)
        file << "+";
      file << " : " << chr_name[bfs[i].cr] << endl;
      }
    }
  return;
}

void aus_komb(ostream& file, int n)
{
  int i, v;
  for(i = 0; i < n; i++)
    {
    file << betrag(f_komb[i]) + 1;
    if((v = vorz(f_komb[i])) < 0)
      file << "-";
    else if(v > 0)
      file << "+";
    file << " ";
    }
  return;
}

int diag_parallelen(int *vh, int *nh, int n, int *l)
{
  int i, j, ivl, ni, vi, nj, par_flag;
  for(i = 0, par_flag = OHNE_PARALL; i < n - 1; i++)
    {
    if((ni = nh[i]) != PAUSE && (vi = vh[i]) != PAUSE)
      if(ni != vi)
        for(j = i + 1; j < n; j++)
          {
          if((nj = nh[j]) != PAUSE)
            if((ivl = (betrag(ni - nj) % 7)) == QUINT || ivl == PRIM)
              if(ni - nj == vi - vh[j])
                {
                par_flag = MIT_PARALL;
                *l++ = i;
                *l++ = j;
                }
          }
    }
  *l = ENDE_FEHLER;
  return(par_flag);
}

int diag_bq(int *v, int n, int *l)
{
  int bs_ton, akk, i, j, t;

  for(akk = i = 0, bs_ton = PAUSE; i < n; i++)
    {
    if((t = v[i]) != PAUSE)
      {
      if(bs_ton == PAUSE || bs_ton > t)
        bs_ton = t;
      akk |= (1 << pitch_class(t));
      }
    }
  if(akk == 0 || ((1 << pitch_class(bs_ton + QUART)) & akk) == 0)
    {
    *l = ENDE_FEHLER;
    return(KONS);
    }
  for(i = 0; i < n; i++)
    if(v[i] == bs_ton)
      for(j = 0; j < n; j++)
        if(v[j] != PAUSE && j != i)
          if(((v[j] - bs_ton) % 7) == QUART)
            {
            *l++ = i;
            *l++ = j;
            }
  *l = ENDE_FEHLER;
  return(DISS);
}

int	diag_kons(int *v, int n, int *l)
{
  int i, j, b, kons_grad;
  kons_grad = KONS;
  for(i = 0; i < n - 1; i++)
    for(j = i + 1; j < n; j++)
      if(v[i] != PAUSE  && v[j] != PAUSE)
        if((b = betrag(v[i] - v[j]) % 7) == SEKUND || b == SEPTIM)
          {
          kons_grad = DISS;
          *l++ = i;
          *l++ = j;
          }
  *l = ENDE_FEHLER;
  return(kons_grad);
}

int	satz_pruefung(int *v, int abst)
{
  int b, i, j, k, t, fehlerrang, *a1, *a2, *h;
  int akkord1[MAXSTIM];
  int akkord2[MAXSTIM];
  int fehler[MAXSTIM * (MAXSTIM - 1) / 2];

  for(i = 0; i < anz_stim; i++)
    for(j = 0; j < MAXTIEF; j++)
      satz[i][j] = PAUSE;
  for(i = 0; i < anz_stim; i++)
    for(j = 0, t = i_abs[i]; j <= abst; j++)
      {
      satz[i][j + r_abs[i]] = t;
      t += v[j];
      }
  fehlerrang = abst + 1;
  a1 = akkord1;
  a2 = akkord2;
  for(i = 0; i <= abst + maxabst; i++)
    {
    for(j = 0; j < anz_stim; j++)
      a1[j] = satz[j][i];
    diag_kons(a1, anz_stim, fehler);
    for(k = 0; fehler[k] != ENDE_FEHLER; k += 2)
      if((b = betrag(r_abs[fehler[k]] - r_abs[fehler[k + 1]])) < fehlerrang)
        fehlerrang = b;
    if(i == maxabst && quart_flag == KORRQUART)
      {
      diag_bq(a1, anz_stim, fehler);
      if(fehler[0] != ENDE_FEHLER && maxabst < fehlerrang)
        fehlerrang = maxabst;
      }
    if(i > 0)
      {
      diag_parallelen(a1, a2, anz_stim, fehler);
      for(k = 0; fehler[k] != ENDE_FEHLER; k += 2)
        if((b = betrag(r_abs[fehler[k]] - r_abs[fehler[k + 1]])) < fehlerrang)
          fehlerrang = b;
      }
    h = a1;
    a1 = a2;
    a2 = h;
    }
  return(fehlerrang);
}

void	konstr_var(ostream& file, int n, int modus, int chr)
{
  int i, v, fehlerrang, akt_chr;
  if(n >= var_len)
    {
    if(modus == VAR_AUSGABE)
      {
      file << "V";
      for(i = 0; i < var_len; i++)
        {
        file << betrag(variation[i]) + 1;
        if((v = vorz(variation[i])) < 0)
          file << "-";
        else if(v > 0)
          file << "+";
        }
      }
    fehlerrang = satz_pruefung(variation, var_len);
    if(fehlerrang > var_len)
      {
      z_regulaer++;
      akt_chr = minimum(chr, IMPERFEKTIV);
      }
    else if(fehlerrang == var_len)
      {
      z_irregulaer++;
      akt_chr = DISSONATIV;
      }
    else
      {
      z_irrelevant++;
      akt_chr = IRRELEVANT;
      }
    if(modus == VAR_AUSGABE)
      file << chr_name[akt_chr] << endl;
    }
  else
    for(i = 0; i < anz_versch; i++)
      if(var_haeuf[i] < haeuf[i])
        {
        var_haeuf[i]++;
        variation[n] = basis[i];
        konstr_var(file, n + 1, modus, chr);
        var_haeuf[i]--;
        }
  return;
}

void ini_var(int l)
{
  int i, letzt;
  var_len = l;
  anz_versch = 0;
  for(i = 0; i < var_len; i++)
    {
    if(i == 0 || f_komb[i] != letzt)
      {
      haeuf[anz_versch] = 1;
      basis[anz_versch++] = letzt = f_komb[i];
      }
    else
      haeuf[anz_versch - 1]++;
    }
  for(i = 0; i < anz_versch; i++)
    var_haeuf[i] = 0;
}

void vollst_bew(ostream& file, int ntk, int chr)
{
  int i, ges_fs, k_qu_chr, laenge, alt_quart, akt_chr;
  laenge = alletks[ntk].rhy_abs;
  for(ges_fs = i = 0; i < laenge; i++)
    ges_fs += f_komb[i];
  alt_quart = quart_flag;
  quart_flag = KONS;
  k_qu_chr = charakter(ges_fs - alletks[ntk].ivl_abs);
  for(i = ntk + 1; i < anz_tks && alletks[i].rhy_abs == laenge; i++)
    k_qu_chr = minimum(charakter(ges_fs - alletks[i].ivl_abs), k_qu_chr);
  quart_flag = alt_quart;
  z_irrelevant = z_regulaer = z_irregulaer = 0;
  ini_var(laenge);
  konstr_var(file, 0, VAR_BERECHNUNG, IMPERFEKTIV);
  if(z_regulaer == 0)
    akt_chr = (z_irregulaer == 0 ? IRRELEVANT : DISSONATIV);
  else
    akt_chr = (z_irregulaer == 0 ? k_qu_chr : AMBIVALENT);
  if(akt_chr == chr)
    {
    aus_komb(file, laenge);
    file << endl;
    if(chr == AMBIVALENT)
      konstr_var(file, 0, VAR_AUSGABE, k_qu_chr);
    }
  return;
}

void al_komb_wdh(ostream& file, int n, int k, int min, int bis, int ntk, int chr)
{
  int i;
  if(bis >= k)
    vollst_bew(file, ntk, chr);
  else
    for(i = min; i < n; i++)
      {
      f_komb[bis] = bfs[i].fs;
      al_komb_wdh(file, n, k, i, bis + 1, ntk, chr);
      }
	return;
}

void kombinationen(ostream& file)
{
  int i, j;
  for(i = 0; i < anz_tks && alletks[i].rhy_abs < 2; i++)
    ;
  for(; i < anz_tks; i++)
    if(i == 0 || alletks[i].rhy_abs != alletks[i - 1].rhy_abs)
      for(j = IRRELEVANT; j < AMBIVALENT 
          || (alletks[i].rhy_abs == maxabst && j == AMBIVALENT); j++)
        {
        file << chr_name[j] << endl;
        al_komb_wdh(file, anz_bfs, alletks[i].rhy_abs, ANFANG, ANFANG, i, j);
        }
	  return;
}

void fest_quart_k(ostream& file, int chr)
{
  quart_flag = chr;
  unt_tks();
  brauchbare_fs();
  aus_bfs(file);
  kombinationen(file);
}

void test()
{
  char  c;
  kanon_schema();
  weite();
  kgra_kopf(cout);
  ber_tks();
  sort_tks();
  versch_tks();
  fest_quart_k(cout, KONS);
  fest_quart_k(cout, KORRQUART);
  cout << "Abspeichern? (j/n)" << endl;
  do
    cin >> c;
  while(c != 'j' && c != 'n' && c != 'J' && c != 'N');
  if(c == 'j' || c == 'J')
    {
    if(!f_sp.is_open())
      {
      f_sp.open("KIK.ASC", ios::out);
      if(f_sp == NULL)
        {
        cout << "Abspeichern nicht mglich" << endl;
        return;
        }
      }
    kgra_kopf(f_sp);
    fest_quart_k(f_sp, KONS);
    fest_quart_k(f_sp, KORRQUART);
    }
	return;
}

int main(int argc, char* argv[])
{
  char  c;
  do
    {
    test();
    do
      {
      cout << "Neuer Test? (j/n)" << endl;
      cin >> c;
      }
      while(c != 'j' && c != 'J' && c != 'n' && c != 'N');
    }
    while(c == 'j' || c == 'J');

	return 0;
}
