// Copyright (C) 2012 Stefan Prey
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// 
// 
// This file is part of kanonprogramme.
// 
// kanonprogramme is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// kanonprogramme is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with kanonprogramme.  If not, see <http://www.gnu.org/licenses/>.
// 
// Diese Datei ist Teil von kanonprogramme.
// 
// kanonprogramme ist Freie Software: Sie koennen es unter den Bedingungen
// der GNU General Public License, wie von der Free Software Foundation,
// Version 3 der Lizenz oder (nach Ihrer Option) jeder spaeteren
// veroeffentlichten Version, weiterverbreiten und/oder modifizieren.
// 
// kanonprogramme wird in der Hoffnung, dass es nuetzlich sein wird, aber
// OHNE JEDE GEWAEHELEISTUNG, bereitgestellt; sogar ohne die implizite
// Gewaehrleistung der MARKTFAEHIGKEIT oder EIGNUNG FUER EINEN BESTIMMTEN ZWECK.
// Siehe die GNU General Public License fuer weitere Details.
// 
// Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
// Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
#include "StdAfx.h"
#include "graph.h"

graph::graph(int n)
{
    m_anzahl_knoten = n;
    m_die_knoten = new knoten [m_anzahl_knoten];
    if(m_die_knoten == NULL)
	exit(1);
}

graph::~graph()
{
    delete[] m_die_knoten;
}

void graph::einfuegen(int nummer, const knoten& ausgangsknoten)
{
    m_die_knoten[nummer] = ausgangsknoten;
}

folge graph::zufallsfolge(int laenge)
{
//Zufaelliger Einstiegsknoten
    zufall z;
    int* zwischenspeicher = new int [laenge];
    if(zwischenspeicher == NULL)
	exit(1);
    int wert = 0; // Startwert
    int zaehler = 0;
    zwischenspeicher[zaehler++] = wert; // Anfangswert speichern
    int knotennummer = z.zufallszahl_bis(m_anzahl_knoten);

    while(zaehler < laenge)
    {
	wert += m_die_knoten[knotennummer].get_wert();
	zwischenspeicher[zaehler++] = wert;

	int anzahl_adjazenzen = m_die_knoten[knotennummer].get_anzahl_adjazenzen();
	if(anzahl_adjazenzen == 0)
	{
	    folge wertefolge(zaehler, zwischenspeicher);
	    return wertefolge;
	}
	else if(anzahl_adjazenzen == 1)
	{
	    knotennummer = m_die_knoten[knotennummer].get_adjazenz_nummer(0);
	}
	else
	{
	    int zufaelliger_folgeknoten = z.zufallszahl_bis(m_die_knoten[knotennummer].get_anzahl_adjazenzen());
	    knotennummer = m_die_knoten[knotennummer].get_adjazenz_nummer(zufaelliger_folgeknoten);
	}
    }
    folge wertefolge(zaehler, zwischenspeicher);
    return wertefolge;
}
